using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace BunnyMark
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        // Automatically created stuff. C# syntax is datatype first, then variable name.
        
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        // My stuff
 
        int numBunnies = 3500;
        float gravity = 3f;
		Bunny[] bunnies;
        int maxX = 800;
        int minX = 0;
        int maxY = 480;
        int minY = 0;
        Random random;
        SpriteFont font;
        FPS fps;

		public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            //IsFixedTimeStep = false;
            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);
            //TargetElapsedTime = TimeSpan.FromTicks(333333);

            //IsFixedTimeStep = false;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // Load the bunny texture. This is like making a new BitmapData from an embedded asset in Flash.

            Texture2D bunnyTexture = this.Content.Load<Texture2D>("wabbit_alpha");

            font = Content.Load<SpriteFont>("FPSFont");

            // Make some bunnies

            random = new Random();

            bunnies = new Bunny[numBunnies];

            for (int i = 0; i < numBunnies; i++)
            {
                Bunny bunny = new Bunny();
                bunny.position = new Vector2(0, 0);
                bunny.velocity = new Vector2((float)random.NextDouble() * 10f, ((float)random.NextDouble() * 10f) - 5f);
                Console.WriteLine(bunny.velocity.ToString());
                bunny.texture = bunnyTexture;
                bunnies[i] = bunny;
            }

            fps = new FPS();
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

           	Bunny bunny;
			
			for (int i = 0; i < numBunnies; i++)
			{
				bunny = bunnies[i];
                bunny.position += bunny.velocity;
                bunny.velocity.Y += gravity;
				
				if (bunny.position.X > maxX)
				{
                    bunny.velocity.X *= -1f;
					bunny.position.X = maxX;
				}
				else if (bunny.position.X < minX)
				{
                    bunny.velocity.X *= -1f;
					bunny.position.X = minX;
				}
				
				if (bunny.position.Y > maxY)
				{
					bunny.velocity.Y *= -0.8f;
					bunny.position.Y = maxY;
					
					if ((float)random.NextDouble() > 0.5f)
					{
                        bunny.velocity.Y -= (float)random.NextDouble() * 12;
					}
				} 
				else if (bunny.position.Y < minY)
				{
					bunny.velocity.Y = 0f;
					bunny.position.Y = minY;
				}
			}

            //fps.update();

			base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            fps.update();

            GraphicsDevice.Clear(Color.CornflowerBlue);

            Bunny bunny;

            spriteBatch.Begin();

            for (int i = 0; i < numBunnies; i++)
            {
                bunny = bunnies[i];
                spriteBatch.Draw(bunny.texture, bunny.position, Color.White);
            }

            spriteBatch.DrawString(font, fps.fpsText, new Vector2(20, 45), Color.White);

            spriteBatch.End();

            base.Draw(gameTime);
           
        }
    }
}
